Assignee:

Category: Symbology

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 15442
Description

In the new symbology mode, at least in 1.8.0, several classification modes render negative real values as though they were positive
values. This occurs with Quantile, Natural Breaks and Standard Deviation classifications. It also fails completely to classify percentages
stored as reals (-1 to 1) in Equal Interval and Pretty Breaks modes.

| have import data (from either CSV or XLS) and join it to a vector layer. The data is attached, although with identifying information
stripped out because it's embargoed.

The values range from -0.0791 to 0.0165 and are stored as reals. The classifications are a mess; for instance, here's the classification in
Quantile mode, in order from lightest color to darkest for 7 categories:

0.0000 - -0.0342
-0.0342 - -0.0185
-0.0185 - 0.0000
0.0000 - 0.0000
0.0000 - 0.0000
0.0000 - 0.0000
0.0000 - 0.0165

I don't know why it includes three categories of 0-0, but it leads to misleading categorization. The data has a MIN of -0.0791 so it should
be something like

-0.0791 - -0.0345
-0.0342 - -0.0185
-0.0185 - 0.0000
0.0000 - 0.0165

off the top of my head, although of course that's only 4 categories. There are 56 data points, so it's not for lack of trying.

Associated revisions

Revision 7¢0746b0 - 2013-03-04 11:47 PM - Nathan Woodrow

Merge pull request #453 from nyalldawson/gradfixes

Don't treat null values as zero for graduated symbology (Fix #6096)

History

#1 - 2012-07-25 09:35 AM - Giovanni Manghi
- Status changed from Open to Feedback
- Category set to Symbology

Can you check if this is a regression since 1.7.4?

#2 - 2012-07-25 09:54 AM - Wes Meltzer

Giovanni Manghi wrote:

Can you check if this is a regression since 1.7.4?

Short answer: no. | never upgraded from 1.7.1 to 1.7.4 (lazy) but this issue is present in 1.7.1. It's hard to believe | never had a data set consisting of mostly

negative reals with 1.7!

Note: | discovered one issue that is a red herring. The weirdness with the excess 0.00 values listed above is actually a problem with the dataset the
database reporter generated, which only showed up in quantiles mode. Too many null values. This is not an issue with the Quantiles categorization. The

negative numbers issue remains if | change the mode, however.

Here is the Jenks categorization for 1.7.1 and 1.8.0:

0.0000 - -0.0714
-0.0714 - -0.0420
-0.0420 - -0.0282
-0.0282 - -0.0185
-0.0185 - -0.0083
-0.0083 - 0.0030

0.0030 - 0.0165

which is still erroneous without manually changing the order of processing. Top line should be -0.0791 - -0.0714.

#3 - 2012-07-27 03:37 AM - Giovanni Manghi

- Status changed from Feedback to Open

- Target version set to Version 2.0.0

#4 - 2013-03-03 06:46 PM - Nyall Dawson

By my testing this is fixed by pull request 453:

https://github.com/qgis/Quantum-GIS/pull/453

#5 - 2013-03-04 02:47 PM - Nathan Woodrow
- Status changed from Open to Closed

Fixed in changeset commit:"7c0746b091498dbe741c34396f7da5bff51030da".
https://github.com/qgis/Quantum-GIS/pull/453

sample_zip_code_data.xls 19 KB 2012-07-25 Wes Meltzer
Screen_shot_2012-07-25_at_11.47.29_AM.png 86.7 KB 2012-07-25 Wes Meltzer
zipcodes_new.zip 1010 KB 2012-07-25 Wes Meltzer
